> ## Documentation Index
> Fetch the complete documentation index at: https://docs.galileo.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Apply Bulk Feedback V2



## OpenAPI

````yaml https://api.galileo.ai/public/v2/openapi.json post /v2/projects/{project_id}/feedback/ratings
openapi: 3.1.0
info:
  title: FastAPI
  version: 0.1.0
servers:
  - url: https://api.galileo.ai
    description: Galileo Public APIs - galileo-v2
security: []
paths:
  /v2/projects/{project_id}/feedback/ratings:
    post:
      tags:
        - feedback
      summary: Apply Bulk Feedback V2
      operationId: apply_bulk_feedback_v2_v2_projects__project_id__feedback_ratings_post
      parameters:
        - name: project_id
          in: path
          required: true
          schema:
            type: string
            format: uuid4
            title: Project Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BulkFeedbackRequest'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/BulkFeedbackRatingStatus'
                title: >-
                  Response Apply Bulk Feedback V2 V2 Projects  Project Id 
                  Feedback Ratings Post
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      deprecated: true
      security:
        - APIKeyHeader: []
        - OAuth2PasswordBearer: []
        - HTTPBasic: []
components:
  schemas:
    BulkFeedbackRequest:
      properties:
        operations:
          items:
            oneOf:
              - $ref: '#/components/schemas/BulkFeedbackRatingCreate'
              - $ref: '#/components/schemas/BulkFeedbackRatingDelete'
            discriminator:
              propertyName: operation_type
              mapping:
                create:
                  $ref: '#/components/schemas/BulkFeedbackRatingCreate'
                delete:
                  $ref: '#/components/schemas/BulkFeedbackRatingDelete'
          type: array
          title: Operations
        selector:
          oneOf:
            - $ref: '#/components/schemas/IndexSelector'
            - $ref: '#/components/schemas/TraceSelector'
          title: Selector
          discriminator:
            propertyName: selector_type
            mapping:
              indexes:
                $ref: '#/components/schemas/IndexSelector'
              traces:
                $ref: '#/components/schemas/TraceSelector'
      type: object
      required:
        - operations
        - selector
      title: BulkFeedbackRequest
    BulkFeedbackRatingStatus:
      properties:
        selector:
          $ref: '#/components/schemas/SelectorType'
          default: indexes
        index:
          anyOf:
            - type: integer
            - type: 'null'
          title: Index
        trace:
          anyOf:
            - type: string
              format: uuid4
            - type: 'null'
          title: Trace
        operation:
          $ref: '#/components/schemas/FeedbackRatingOperationType'
        success:
          type: boolean
          title: Success
        message:
          anyOf:
            - type: string
            - type: 'null'
          title: Message
      type: object
      required:
        - operation
        - success
        - message
      title: BulkFeedbackRatingStatus
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    BulkFeedbackRatingCreate:
      properties:
        explanation:
          anyOf:
            - type: string
              minLength: 1
            - type: 'null'
          title: Explanation
        rating:
          oneOf:
            - $ref: >-
                #/components/schemas/libs__python__schemas__log_records__feedback__LikeDislikeRating
            - $ref: >-
                #/components/schemas/libs__python__schemas__log_records__feedback__StarRating
            - $ref: >-
                #/components/schemas/libs__python__schemas__log_records__feedback__ScoreRating
            - $ref: >-
                #/components/schemas/libs__python__schemas__log_records__feedback__TagsRating
            - $ref: >-
                #/components/schemas/libs__python__schemas__log_records__feedback__TextRating
          title: Rating
          discriminator:
            propertyName: feedback_type
            mapping:
              like_dislike:
                $ref: >-
                  #/components/schemas/libs__python__schemas__log_records__feedback__LikeDislikeRating
              score:
                $ref: >-
                  #/components/schemas/libs__python__schemas__log_records__feedback__ScoreRating
              star:
                $ref: >-
                  #/components/schemas/libs__python__schemas__log_records__feedback__StarRating
              tags:
                $ref: >-
                  #/components/schemas/libs__python__schemas__log_records__feedback__TagsRating
              text:
                $ref: >-
                  #/components/schemas/libs__python__schemas__log_records__feedback__TextRating
        feedback_template_id:
          type: string
          format: uuid4
          title: Feedback Template Id
        operation_type:
          type: string
          const: create
          title: Operation Type
          default: create
      type: object
      required:
        - rating
        - feedback_template_id
      title: BulkFeedbackRatingCreate
    BulkFeedbackRatingDelete:
      properties:
        feedback_template_id:
          type: string
          format: uuid4
          title: Feedback Template Id
        operation_type:
          type: string
          const: delete
          title: Operation Type
          default: delete
      type: object
      required:
        - feedback_template_id
      title: BulkFeedbackRatingDelete
    IndexSelector:
      properties:
        selector_type:
          type: string
          const: indexes
          title: Selector Type
          default: indexes
        indexes:
          items:
            type: integer
          type: array
          title: Indexes
      type: object
      required:
        - indexes
      title: IndexSelector
      description: Choose specific indexes to apply the bulk operation to.
    TraceSelector:
      properties:
        selector_type:
          type: string
          const: traces
          title: Selector Type
          default: traces
        traces:
          items:
            type: string
            format: uuid4
          type: array
          title: Traces
      type: object
      required:
        - traces
      title: TraceSelector
      description: Choose specific traces to apply the bulk operation to.
    SelectorType:
      type: string
      enum:
        - indexes
        - traces
      title: SelectorType
    FeedbackRatingOperationType:
      type: string
      enum:
        - create
        - delete
      title: FeedbackRatingOperationType
      description: Operation type for bulk feedback rating operations.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    libs__python__schemas__log_records__feedback__LikeDislikeRating:
      properties:
        feedback_type:
          type: string
          const: like_dislike
          title: Feedback Type
          default: like_dislike
        value:
          type: boolean
          title: Value
      type: object
      required:
        - value
      title: LikeDislikeRating
    libs__python__schemas__log_records__feedback__StarRating:
      properties:
        feedback_type:
          type: string
          const: star
          title: Feedback Type
          default: star
        value:
          type: integer
          maximum: 5
          minimum: 1
          title: Value
      type: object
      required:
        - value
      title: StarRating
    libs__python__schemas__log_records__feedback__ScoreRating:
      properties:
        feedback_type:
          type: string
          const: score
          title: Feedback Type
          default: score
        value:
          type: integer
          title: Value
      type: object
      required:
        - value
      title: ScoreRating
    libs__python__schemas__log_records__feedback__TagsRating:
      properties:
        feedback_type:
          type: string
          const: tags
          title: Feedback Type
          default: tags
        value:
          items:
            type: string
            maxLength: 255
            minLength: 1
          type: array
          title: Value
      type: object
      required:
        - value
      title: TagsRating
    libs__python__schemas__log_records__feedback__TextRating:
      properties:
        feedback_type:
          type: string
          const: text
          title: Feedback Type
          default: text
        value:
          type: string
          minLength: 1
          title: Value
      type: object
      required:
        - value
      title: TextRating
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      in: header
      name: Galileo-API-Key
    OAuth2PasswordBearer:
      type: oauth2
      flows:
        password:
          scopes: {}
          tokenUrl: https://api.galileo.ai/login
    HTTPBasic:
      type: http
      scheme: basic

````